package org.stepik.android.domain.course_purchase.analytic

import org.stepik.android.domain.base.analytic.AnalyticEvent
import org.stepik.android.model.Course

class BuyCoursePromoSuccessAnalyticEvent(
    course: Course,
    promoName: String
) : AnalyticEvent {
    companion object {
        private const val PARAM_COURSE = "course"
        private const val PARAM_PROMO = "promo"
    }
    override val name: String =
        "Buy course promo success"

    override val params: Map<String, Any> =
        mapOf(
            PARAM_COURSE to course.id,
            PARAM_PROMO to promoName
        )
}